/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the AppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &AppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest{}

// AppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest struct for AppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest
type AppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest struct {
	Service *string                        `json:"service,omitempty"`
	Data    *QuickbooksStaticDtoAuthorizer `json:"data,omitempty"`
}

// NewAppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest instantiates a new AppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest() *AppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest {
	this := AppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest{}
	var service string = "quickbooks_static"
	this.Service = &service
	return &this
}

// NewAppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequestWithDefaults instantiates a new AppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequestWithDefaults() *AppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest {
	this := AppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest{}
	var service string = "quickbooks_static"
	this.Service = &service
	return &this
}

// GetService returns the Service field value if set, zero value otherwise.
func (o *AppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest) GetService() string {
	if o == nil || IsNil(o.Service) {
		var ret string
		return ret
	}
	return *o.Service
}

// GetServiceOk returns a tuple with the Service field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest) GetServiceOk() (*string, bool) {
	if o == nil || IsNil(o.Service) {
		return nil, false
	}
	return o.Service, true
}

// HasService returns a boolean if a field has been set.
func (o *AppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest) HasService() bool {
	if o != nil && !IsNil(o.Service) {
		return true
	}

	return false
}

// SetService gets a reference to the given string and assigns it to the Service field.
func (o *AppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest) SetService(v string) {
	o.Service = &v
}

// GetData returns the Data field value if set, zero value otherwise.
func (o *AppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest) GetData() QuickbooksStaticDtoAuthorizer {
	if o == nil || IsNil(o.Data) {
		var ret QuickbooksStaticDtoAuthorizer
		return ret
	}
	return *o.Data
}

// GetDataOk returns a tuple with the Data field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest) GetDataOk() (*QuickbooksStaticDtoAuthorizer, bool) {
	if o == nil || IsNil(o.Data) {
		return nil, false
	}
	return o.Data, true
}

// HasData returns a boolean if a field has been set.
func (o *AppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest) HasData() bool {
	if o != nil && !IsNil(o.Data) {
		return true
	}

	return false
}

// SetData gets a reference to the given QuickbooksStaticDtoAuthorizer and assigns it to the Data field.
func (o *AppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest) SetData(v QuickbooksStaticDtoAuthorizer) {
	o.Data = &v
}

func (o AppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o AppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Service) {
		toSerialize["service"] = o.Service
	}
	if !IsNil(o.Data) {
		toSerialize["data"] = o.Data
	}
	return toSerialize, nil
}

type NullableAppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest struct {
	value *AppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest
	isSet bool
}

func (v NullableAppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest) Get() *AppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest {
	return v.value
}

func (v *NullableAppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest) Set(val *AppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableAppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableAppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest(val *AppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest) *NullableAppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest {
	return &NullableAppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest{value: val, isSet: true}
}

func (v NullableAppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAppAuthorizerQuickbooksStaticQuickbooksStaticAuthorizerNewRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
